package com.casic.dcms.vm;

import androidx.lifecycle.MutableLiveData;

import com.casic.dcms.model.PublicKeyBean;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.pengxh.androidx.lite.callback.OnObserverCallback;
import com.pengxh.androidx.lite.vm.BaseViewModel;
import com.pengxh.androidx.lite.vm.ObserverSubscriber;

import java.io.IOException;

import okhttp3.ResponseBody;
import rx.Observable;

public class AuthenticateViewModel extends BaseViewModel {
    private final Gson gson = new Gson();
    public MutableLiveData<PublicKeyBean> keyModel = new MutableLiveData<>();

    public void obtainPublicKey() {
        Observable<ResponseBody> keyObservable = RetrofitServiceManager.authenticate();
        ObserverSubscriber.addSubscribe(keyObservable, new OnObserverCallback() {

            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        PublicKeyBean keyDataBean = gson.fromJson(response, new TypeToken<PublicKeyBean>() {
                        }.getType());
                        keyModel.setValue(keyDataBean);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
